/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// TemplateType the model 'TemplateType'
type TemplateType string

// List of TemplateType
const (
	TEMPLATE_TYPE_INTERNAL TemplateType = "internal"
	TEMPLATE_TYPE_WHATS_APP TemplateType = "whatsapp"
)

// All allowed values of TemplateType enum
var AllowedTemplateTypeEnumValues = []TemplateType{
	"internal",
	"whatsapp",
}

func (v *TemplateType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := TemplateType(value)
	for _, existing := range AllowedTemplateTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid TemplateType", value)
}

// NewTemplateTypeFromValue returns a pointer to a valid TemplateType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewTemplateTypeFromValue(v string) (*TemplateType, error) {
	ev := TemplateType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for TemplateType: valid values are %v", v, AllowedTemplateTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v TemplateType) IsValid() bool {
	for _, existing := range AllowedTemplateTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to TemplateType value
func (v TemplateType) Ptr() *TemplateType {
	return &v
}

type NullableTemplateType struct {
	value *TemplateType
	isSet bool
}

func (v NullableTemplateType) Get() *TemplateType {
	return v.value
}

func (v *NullableTemplateType) Set(val *TemplateType) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplateType) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplateType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplateType(val *TemplateType) *NullableTemplateType {
	return &NullableTemplateType{value: val, isSet: true}
}

func (v NullableTemplateType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplateType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

